#include <io8535.h>			// ԽŲ.
#include <ina90.h>

#define     BPS_9600     51
#define     BPS_38400    12

unsigned int	ad_data0;
unsigned char   CommBuff;

void delay_msec(unsigned int p){
    unsigned int i, j;
    
    for(i=0;i<p;i++)
      for(j=0;j<610;j++);
}

void initUART(void){
  UBRR = BPS_9600;
  UCR = 0x98;
}

void initPORT(void){
  DDRB = 0x00;
  DDRC = 0xFF;
  PORTB = 0xFF;
  PORTC = 0xFF;
}

void initADC(void){
  ADMUX = 0;
  ADCSR = 0x85;
}

void Serial_Send(unsigned char t){
  while(!(USR & 0x20));
  UDR = t;
}

#pragma vector = UART_RX_vect
__interrupt void UART_RX_interrupt(void){
  while(!(USR & 0x80));
  CommBuff = UDR;
}

void main(void)
{
  unsigned char temp = 0;
  unsigned char H1Nibble, L1Nibble, H2Nibble, L2Nibble;
  unsigned char hibyte, lobyte;
  
  initPORT();
  initUART();
  initADC();
  _SEI();
					      /* interrupt enable */
  while(1){
    if(CommBuff == 0x02) break;
  }
  
  do{
    ADCSR = ADCSR & 0xEF;   //ADIF = 0;
    ADCSR = ADCSR | 0x40;
    while(1){
      temp = ADCSR ;
      temp = temp & 0x10;
      if(temp == 0x00) break;
    }
    
    ad_data0 = ADC;
    lobyte = (unsigned char)ad_data0;
    hibyte = (unsigned char)(ad_data0 >> 8);
    
    H1Nibble = ((hibyte & 0xF0) >> 4) | 0x30;
    L1Nibble = (hibyte & 0x0F) | 0x30;
    
    H2Nibble = ((lobyte & 0xF0) >> 4) | 0x30;
    L2Nibble = (lobyte & 0x0F) | 0x30;
    
    Serial_Send(0x02);
    Serial_Send(H1Nibble);
    Serial_Send(L1Nibble);
    Serial_Send(H2Nibble);
    Serial_Send(L2Nibble);
    delay_msec(1000);
  }while(1);
}

