#include <io8535.h>			// ԽŲ.
#include <ina90.h>

#define LEFT_MOTOR0       PORTD_Bit4
#define LEFT_MOTOR1       PORTD_Bit6
#define RIGHT_MOTOR1      PORTD_Bit5
#define RIGHT_MOTOR0      PORTD_Bit7

// LED ũ  ũ Լ
#define	    LED_EN	{ PORTC_Bit6 = 1; PORTC_Bit6 = 0; }
#define	    SEG_EN	{ PORTC_Bit5 = 1; PORTC_Bit5 = 0; }

#define	    RobotLED	PORTB
#define	    RobotSEG	PORTB

#define     Buzzer      PORTC_Bit7

#define	    ADC_START	( ADCSR |= 0x40 )
#define	    ADC_STOP	( ADCSR &= 0xbf )
#define	    ADC_EOC	( ADCSR & 0x10 )

// Sensor Enable
#define     PTS_0       { PORTC_Bit2 = 0; PORTC_Bit1 = 0; PORTC_Bit0 = 0; }
#define     PTS_1       { PORTC_Bit2 = 0; PORTC_Bit1 = 0; PORTC_Bit0 = 1; }
#define     PTS_2       { PORTC_Bit2 = 0; PORTC_Bit1 = 1; PORTC_Bit0 = 0; }
#define     PTS_3       { PORTC_Bit2 = 0; PORTC_Bit1 = 1; PORTC_Bit0 = 1; }
#define     PTS_4       { PORTC_Bit2 = 1; PORTC_Bit1 = 0; PORTC_Bit0 = 0; }
#define     PTS_5       { PORTC_Bit2 = 1; PORTC_Bit1 = 0; PORTC_Bit0 = 1; }
#define     PTS_6       { PORTC_Bit2 = 1; PORTC_Bit1 = 1; PORTC_Bit0 = 0; }
#define     PTS_OFF     { PORTC_Bit2 = 1; PORTC_Bit1 = 1; PORTC_Bit0 = 1; }

#define     LED_OFF     1
#define     LED_ON      0

#define     left_motor_margin    0
#define     right_motor_margin    0

unsigned char Bit0_SEG, Bit1_SEG, Bit2_SEG, Bit3_SEG, Bit4_SEG, Bit5_SEG, Bit6_SEG;
unsigned char Bit0_LED, Bit1_LED, Bit2_LED, Bit3_LED, Bit4_LED, Bit5_LED, Bit6_LED;

int	ad_data0,ad_data1,ad_data2,ad_data3,ad_data4,ad_data5,ad_data6;
int ad_ref,ad_num;
unsigned char study_flag=0, start_flag=0;
long sen_count = 0;

unsigned int g_time_L=0,g_time_R=0;
char direc_L;
char direc_R;
unsigned int pwm_L;
unsigned int pwm_R;
unsigned int pwm_LEFT;
unsigned int pwm_RIGHT;
unsigned int battery;
void Sen_AD_con(void);
void Sen_LED_output(void);

#pragma vector = INT0_vect
__interrupt void INT0_interrupt(void)
{
      study_flag = 1;
}

#pragma vector = INT1_vect
__interrupt void INT1_interrupt(void)
{
      start_flag = 1;
}

#pragma vector = TIMER0_OVF0_vect
__interrupt void TIMER0_OVR0_interrupt(void)
{
	
	Sen_AD_con();
        Sen_LED_output();
	g_time_L++;
	g_time_R++;
	//pwm_L=g_time_L;
	//pwm_R=g_time_R;

	if((g_time_L<pwm_LEFT) && (direc_L == '-'))
	{
		LEFT_MOTOR1=1;
		LEFT_MOTOR0=0;
	}
	
	if((g_time_L<pwm_LEFT) && (direc_L == '+'))
	{
		LEFT_MOTOR1=0;
		LEFT_MOTOR0=1;
	}
	
	if(g_time_L>pwm_LEFT)
	{
		LEFT_MOTOR1=0;
		LEFT_MOTOR0=0;
	}

	if((g_time_R<pwm_RIGHT) && (direc_R == '-'))
	{
		RIGHT_MOTOR1=0;
		RIGHT_MOTOR0=1;
	}
	if((g_time_R<pwm_RIGHT) && (direc_R == '+'))
	{
		RIGHT_MOTOR1=1;
		RIGHT_MOTOR0=0;
	}
	if(g_time_R>pwm_RIGHT)
	{
		RIGHT_MOTOR1=0;
		RIGHT_MOTOR0=0;
	}
	
	if(g_time_R==100) g_time_R=0;
	if(g_time_L==100) g_time_L=0;
}
void delay(long d_t){
    long i;
    
    for(i=0;i<d_t;i++);
}

// Ʈ ʱȭ Լ
void initPORT(void){
        
        MCUCR = 0x0a;
        GIMSK = 0xc0;
        TCCR0 = 0x02;
    	TIMSK = 0x01;
    	TCNT0 = 0x00;
    	
    	TIFR = 0;
    	//GIMSK = 0;
    	
	DDRB = 0xFF;    DDRC = 0xFF;	DDRA = 0x00;
	PORTB = 0xFF;	PORTC = 0x00;	PORTA = 0x00;
}

void initADC(void)
{
	ADMUX = 1;		
	ADCSR = 0x85;		
}

		      
void Sen_AD_con(void)
{
      //RobotLED = 0xff;
      
            switch(ad_num)
                {
                case 0:
                      PTS_0;
                      ADMUX = 0x01;		  // ADC1 conversion start 
		      ADCSR |= 0X40;	  // wait until End of Conversion 
		      while(!(ADCSR & 0x10));
		      ad_data0 = ADC;
		      ad_num = 1;
		      
		break;
		case 1:
                      PTS_1;
		      ADMUX = 0x02;		  // ADC2 conversion start 
		      ADCSR |= 0X40;	  // wait until End of Conversion 
		      while(!(ADCSR & 0x10));
		      ad_data1 = ADC;
		      ad_num = 2;
		      
		break;
		case 2:
                      PTS_2;
		      ADMUX = 0x03;		  // ADC3 conversion start 
		      ADCSR |= 0X40;	  // wait until End of Conversion 
		      while(!(ADCSR & 0x10));
		      ad_data2 = ADC;
		      ad_num = 3;
		break;
		case 3:
                      PTS_3;
		      ADMUX = 0x04;		  // ADC4 conversion start 
		      ADCSR |= 0X40;	  // wait until End of Conversion 
		      while(!(ADCSR & 0x10));
		      ad_data3 = ADC;
		      ad_num = 4;
		break;
		case 4:
                      PTS_4;
		      ADMUX = 0x05;		  // ADC5 conversion start 
		      ADCSR |= 0X40;	  // wait until End of Conversion 
		      while(!(ADCSR & 0x10));
		      ad_data4 = ADC;
		      ad_num = 5;
		break;
		case 5:
                      PTS_5;
		      ADMUX = 0x06;		  // ADC6 conversion start 
		      ADCSR |= 0X40;	  // wait until End of Conversion 
		      while(!(ADCSR & 0x10));
		      ad_data5 = ADC;
		      ad_num = 6;
		break;
		case 6:
                      PTS_6;
		      ADMUX = 0x07;		  // ADC7 conversion start 
		      ADCSR |= 0X40;	  // wait until End of Conversion 
		      while(!(ADCSR & 0x10));
		      ad_data6 = ADC;
		      ad_num = 0;
		      
		break;
		}
}

void Sen_LED_output(void)
{
        
        if( ad_ref <ad_data0 ) Bit0_LED = 0xfe;  
        else   Bit0_LED = 0xff;  
        
        if( ad_ref <ad_data1 )  Bit1_LED = 0xfd; 
        else   Bit1_LED = 0xff;  
        
        if( ad_ref <ad_data2 )  Bit2_LED = 0xfb;  
        else   Bit2_LED = 0xff;  
        
        if( ad_ref <ad_data3 )  Bit3_LED = 0xf7;  
        else   Bit3_LED = 0xff;  
        
        if( ad_ref <ad_data4 )  Bit4_LED = 0xef;  
        else  Bit4_LED = 0xff;  
        
        if( ad_ref <ad_data5 )  Bit5_LED = 0xdf; 
        else   Bit5_LED = 0xff;  
        
        if( ad_ref <ad_data6 )  Bit6_LED = 0xbf;  
        else   Bit6_LED = 0xff;  
        
        RobotLED = ( Bit0_LED & Bit1_LED & Bit2_LED & Bit3_LED & Bit4_LED & Bit5_LED & Bit6_LED );
        LED_EN;
        
}
	
void Sen_SEG_output(void)
{
        
        if( ad_ref <ad_data0 ) Bit0_SEG = 0xfe;  
        else   Bit0_SEG = 0xff;  
        
        if( ad_ref <ad_data1 )  Bit1_SEG = 0xfd; 
        else   Bit1_SEG = 0xff;  
        
        if( ad_ref <ad_data2 )  Bit2_SEG = 0xfb;  
        else   Bit2_SEG = 0xff;  
        
        if( ad_ref <ad_data3 )  Bit3_SEG = 0xf7;  
        else   Bit3_SEG = 0xff;  
        
        if( ad_ref <ad_data4 )  Bit4_SEG = 0xef;  
        else  Bit4_SEG = 0xff;  
        
        if( ad_ref <ad_data5 )  Bit5_SEG = 0xdf; 
        else   Bit5_SEG = 0xff;  
        
        if( ad_ref <ad_data6 )  Bit6_SEG = 0xbf;  
        else   Bit6_SEG = 0xff;  
        
        RobotSEG = ~( Bit0_SEG & Bit1_SEG & Bit2_SEG & Bit3_SEG & Bit4_SEG & Bit5_SEG & Bit6_SEG );
        SEG_EN;
        
}

void motor_move(char direct_LEFT,char direct_RIGHT,unsigned int wt_L,unsigned int wt_R,long times)
{	
	direc_L=direct_LEFT;
	direc_R=direct_RIGHT;
	pwm_LEFT=wt_L;
	pwm_RIGHT=wt_R;
	delay(times);
}

void motor_line_st_go(void)
{
        //sen_count++;
        if(ad_data3>ad_ref) motor_move('+','+',90-battery-left_motor_margin,90-battery-right_motor_margin,10);
	if(ad_data2>ad_ref) motor_move('+','+',90-battery-left_motor_margin,95-battery-right_motor_margin,10);
	if(ad_data4>ad_ref) motor_move('+','+',95-battery-left_motor_margin,90-battery-right_motor_margin,10);
	if(ad_data1>ad_ref) motor_move('+','+',45-battery-left_motor_margin,100-battery-right_motor_margin,10);
	if(ad_data5>ad_ref) motor_move('+','+',100-battery-left_motor_margin,45-battery-right_motor_margin,10);
}


void motor_stop(void)
{
         while(1){
               motor_move('+','+',0,0,1); 
               }
}


void motor_right_turn(void)
{
 long i;
	while(1){ 
	        motor_move('+','+',100-battery,100-battery,1);
	        if( ad_data6 < ad_ref ) break;
	        }
	        motor_move('+','-',100-battery,100-battery,60000);
	while(1){
	         motor_move('+','-',100-battery,70-battery,1);
	         if( ad_data5 > ad_ref ) break;
	         }
	motor_move('-','+',70-battery,100-battery,10000);
	         
	for(i = 0 ; i<300; i++) motor_line_st_go(); 
	         
	//motor_stop();
}
	
void motor_left_turn(void)
{
	 long i;
	while(1){ 
	        motor_move('+','+',100-battery,100-battery,1);
	        if( ad_data0 < ad_ref ) break;
	        } motor_move('-','+',100-battery,100-battery,60000);
	while(1){
	         motor_move('-','+',70-battery,100-battery,1);
	         if( ad_data1 > ad_ref ) break;
	         }
	motor_move('+','-',100-battery,70-battery,10000);
	for(i = 0 ; i<300; i++) motor_line_st_go();
	//motor_stop();
}
   
void motor_u_turn(void)
{
        //delay(100);
        while(1){
	      motor_move('-','+',95-battery,95-battery,1);
	      if(ad_data1 > ad_ref) break;
	      }motor_move('+','-',95-battery,95-battery,10000);
}

void motor_str(void)
{
              motor_move('+','+',100-battery,100-battery,30000);
}

          
void main(void)
{
        //int i;
	initPORT();
	initADC();
	_SEI();
	
	RobotSEG = 0x00;
	SEG_EN;
	
	//ad_ref = 300;
	ad_num = 0;
	Buzzer = 1;  //Buzzer OFF
	battery = 15;
					      /* interrupt enable */
	while(1){
	
	     if(study_flag == 1){	     
	                  Sen_AD_con();
	                  ad_ref = ((ad_data3 + (ad_data0 + ad_data6)/2) / 2);
	                  
	                  study_flag = 0;
	                  }
      	     
	     if(start_flag == 1){
	            while(1){
	                    motor_line_st_go();
	                    if(ad_data6 > ad_ref) break;
	                    }motor_right_turn();
	            while(1){
	                    motor_line_st_go();
	                    if(ad_data6 > ad_ref) break;
	                    }motor_right_turn();
	            while(1){
	                    motor_line_st_go();
	                    if(ad_data0 > ad_ref) break;
	                    }motor_left_turn();
	            while(1){
	                    motor_line_st_go();
	                    if(ad_data6 > ad_ref) break;
	                    }motor_right_turn();
	            while(1){
	                    motor_line_st_go();
	                    if(ad_data0 > ad_ref) break;
	                    }motor_left_turn();
	            while(1){
	                    motor_line_st_go();
	                    if(ad_data0 > ad_ref) break;
	                    }motor_left_turn();
	            while(1){
	                    motor_line_st_go();
	                    if(ad_data0 > ad_ref) break;
	                    }motor_str();
	            while(1){
	                    motor_line_st_go();
	                    //delay(100);
	                    if((ad_data0 < ad_ref)&&(ad_data1 < ad_ref)&&(ad_data2 < ad_ref)&&(ad_data3 < ad_ref)&&(ad_data4 < ad_ref)&&(ad_data5 < ad_ref)&&(ad_data6 < ad_ref)) break;
	                    }motor_u_turn();
	            while(1){
	                    motor_line_st_go();
	                    if(ad_data6 > ad_ref) break;
	                    }motor_str();
	            while(1){
	                    motor_line_st_go();
	                    if(ad_data6 > ad_ref) break;
	                    }motor_right_turn();
	            while(1){
	                    motor_line_st_go();
	                    if(ad_data6 > ad_ref) break;
	                    }motor_right_turn();        
	            
	            while(1){
	                    motor_line_st_go();
	                    if(ad_data0 > ad_ref) break;
	                    }motor_left_turn();
	            while(1){
	                    motor_line_st_go();
	                    if(ad_data6 > ad_ref) break;
	                    }motor_right_turn();
	            while(1){
	                    motor_line_st_go();
	                    if(ad_data0 > ad_ref) break;
	                    }motor_left_turn();
	            while(1){
	                    motor_line_st_go();
	                    if(ad_data0 > ad_ref) break;
	                    }motor_left_turn();
	            while(1){
	                    motor_line_st_go();
	                    delay(10000);
	                    if((ad_data0 < ad_ref)&&(ad_data1 < ad_ref)&&(ad_data2 < ad_ref)&&(ad_data3 < ad_ref)&&(ad_data4 < ad_ref)&&(ad_data5 < ad_ref)&&(ad_data6 < ad_ref)) break;
	                    }motor_stop();
	            
	           }
      	}
}
